Index: /XIOS/trunk/src/node/domain.cpp
===================================================================
--- /XIOS/trunk/src/node/domain.cpp	(revision 665)
+++ /XIOS/trunk/src/node/domain.cpp	(revision 666)
@@ -138,7 +138,4 @@
      checkLocalIDomain();
      checkLocalJDomain();
-
-     ibegin_client = ibegin; ni_client = ni; iend_client = ibegin + ni - 1;
-     jbegin_client = jbegin; nj_client = nj; jend_client = jbegin + nj - 1;
 
      if (i_index.isEmpty())
@@ -340,5 +337,5 @@
             data_i_index.resize(dni) ;
             data_j_index.resize(dni) ;
-            data_n_index.setValue(dni);
+
             for (int i = 0; i < dni; ++i)
             {
@@ -353,6 +350,4 @@
             data_j_index.resize(dni) ;
 
-            data_n_index.setValue(dni);
-
             for(int count = 0, j = 0; j  < data_nj.getValue(); ++j)
             {
@@ -367,33 +362,12 @@
    }
 
-   void CDomain::completeLonClient()
+   //----------------------------------------------------------------
+   void CDomain::completeLonLatClient(void)
    {
      int i,j,k ;
      CArray<double,1> lonvalue_temp(ni*nj) ;
      CArray<double,2> bounds_lon_temp(nvertex,ni*nj);
-
-     if (!lonvalue_1d.isEmpty() && !lonvalue_2d.isEmpty())
-       ERROR("CDomain::completeLonLatClient(void)",
-            <<"Only one longitude value can be used but both lonvalue_1d and lonvalue_2d are defined! "<<endl
-            <<"Define only one longitude value: lonvalue_1d or lonvalue_2d ");
-
-     if (!lonvalue_1d.isEmpty() && lonvalue_2d.isEmpty())
-     {
-       if (lonvalue_1d.numElements() != i_index.numElements())
-         ERROR("CDomain::completeLonLatClient(void)",
-               <<"lonvalue_1d has not the same size as the local domain"<<endl
-               <<"Local size is "<<i_index.numElements()<<endl
-               <<"lonvalue_1d size is "<<lonvalue_1d.numElements());
-     }
-
-     if (lonvalue_1d.isEmpty() && !lonvalue_2d.isEmpty())
-     {
-        if ((lonvalue_2d.extent(0) != ni) ||
-            (lonvalue_2d.extent(1) != nj))
-           ERROR("CDomain::completeLonLatClient(void)",
-                 <<"the lonvalue has not the same size as the local domain"<<endl
-                 <<"Local size is "<<ni<<"x"<<nj<<endl
-                 <<"Lonvalue size is "<<lonvalue_2d.extent(0)<<"x"<<lonvalue_2d.extent(1));
-     }
+     CArray<double,1> latvalue_temp(ni*nj) ;
+     CArray<double,2> bounds_lat_temp(nvertex,ni*nj);
 
      if (!lonvalue_2d.isEmpty())
@@ -403,8 +377,13 @@
           {
             lonvalue_temp(i+j*ni) = lonvalue_2d(i,j);
+            latvalue_temp(i+j*ni) = latvalue_2d(i,j);
             if (hasBounds)
             {
               k=j*ni+i;
-              for(int n=0;n<nvertex;++n) bounds_lon_temp(n,k) = bounds_lon_2d(n,i,j);
+              for(int n=0;n<nvertex;++n)
+              {
+                bounds_lon_temp(n,k) = bounds_lon_2d(n,i,j);
+                bounds_lat_temp(n,k) = bounds_lat_2d(n,i,j);
+              }
             }
           }
@@ -415,5 +394,5 @@
        if (type_attr::rectilinear == type)
        {
-         if (ni == lonvalue_1d.numElements())
+         if ((ni == lonvalue_1d.numElements()) && (nj == latvalue_1d.numElements()))
          {
            for(j=0;j<nj;++j)
@@ -422,7 +401,12 @@
                k=j*ni+i;
                lonvalue_temp(k) = lonvalue_1d(i);
+               latvalue_temp(k) = latvalue_1d(j);
                if (hasBounds)
                {
-                 for(int n=0;n<nvertex;++n) bounds_lon_temp(n,k) = bounds_lon_1d(n,i);
+                 for(int n=0;n<nvertex;++n)
+                 {
+                   bounds_lon_temp(n,k) = bounds_lon_1d(n,i);
+                   bounds_lat_temp(n,k) = bounds_lat_1d(n,j);
+                 }
                }
              }
@@ -430,117 +414,16 @@
           else
             ERROR("CDomain::completeLonClient(void)",
-                 <<"The lonvalue_1d has not the same size as the local domain"<<endl
-                 <<"Local size is "<<ni<<endl
-                 <<"Lonvalue_1d size is "<<lonvalue_1d.numElements());
+                 <<"lonvalue_1d and latvalue_1d has not the same size as the local domain"<<endl
+                 <<"Local size is "<<ni<<"x " << nj<< endl
+                 <<"lonvalue_1d size is "<<lonvalue_1d.numElements()
+                 <<"latvalue_1d size is "<<latvalue_1d.numElements());
        }
        else if (type==type_attr::curvilinear || type==type_attr::unstructured)
        {
          lonvalue_temp=lonvalue_1d;
+         latvalue_temp=latvalue_1d;
          if (hasBounds)
          {
            bounds_lon_temp=bounds_lon_1d;
-         }
-       }
-     }
-
-     StdSize dm = zoom_ni_client * zoom_nj_client;
-
-      // Make sure that this attribute is non-empty for every client.
-     if (0 != dm)
-     {
-       lonvalue_client.resize(dm);
-       if (hasBounds) bounds_lon_client.resize(nvertex, dm);
-     }
-
-
-     for (i = 0; i < zoom_ni_client; ++i)
-     {
-       for (j = 0; j < zoom_nj_client; ++j)
-       {
-         lonvalue_client(i + j * zoom_ni_client) = lonvalue_temp( (i + zoom_ibegin_client-ibegin) + (j + zoom_jbegin_client -jbegin)*ni );
-         if (hasBounds)
-         {
-           for(int n=0;n<nvertex;n++)
-           {
-             bounds_lon_client(n,i + j * zoom_ni_client) = bounds_lon_temp( n, (i + zoom_ibegin_client - ibegin) + (j + zoom_jbegin_client -jbegin)*ni );
-           }
-         }
-       }
-     }
-   }
-
-   void CDomain::completeLatClient()
-   {
-     int i,j,k;
-     CArray<double,1> latvalue_temp(ni*nj) ;
-     CArray<double,2> bounds_lat_temp(nvertex,ni*nj);
-
-     if (!latvalue_1d.isEmpty() && !latvalue_2d.isEmpty())
-       ERROR("CDomain::completeLonLatClient(void)",
-            <<"Only one longitude value can be used but both latvalue_1d and latvalue_2d are defined! "<<endl
-            <<"Define only one longitude value: latvalue_1d or latvalue_2d ");
-
-     if (!latvalue_1d.isEmpty() && latvalue_2d.isEmpty())
-     {
-       if (latvalue_1d.numElements() != i_index.numElements())
-         ERROR("CDomain::completeLonLatClient(void)",
-               <<"the latvalue_1d has not the same size as the local domain"<<endl
-               <<"Local size is "<<i_index.numElements()<<endl
-               <<"Mask size is "<<latvalue_1d.numElements());
-     }
-
-     if (latvalue_1d.isEmpty() && !latvalue_2d.isEmpty())
-     {
-        if ((latvalue_2d.extent(0) != ni) ||
-            (latvalue_2d.extent(1) != nj))
-           ERROR("CDomain::completeLonLatClient(void)",
-                 <<"the mask has not the same size as the local domain"<<endl
-                 <<"Local size is "<<ni<<"x"<<nj<<endl
-                 <<"Mask size is "<<latvalue_2d.extent(0)<<"x"<<latvalue_2d.extent(1));
-     }
-
-     if (!latvalue_2d.isEmpty())
-     {
-        for (j = 0; j < nj; ++j)
-          for (i = 0; i < ni; ++i)
-          {
-            latvalue_temp(i+j*ni) = latvalue_2d(i,j);
-            if (hasBounds)
-            {
-              k=j*ni+i;
-              for(int n=0;n<nvertex;n++) bounds_lat_temp(n,k) = bounds_lat_2d(n,i,j);
-            }
-          }
-     }
-
-     if (!latvalue_1d.isEmpty())
-     {
-       if (type_attr::rectilinear == type)
-       {
-
-         if (nj == latvalue_1d.numElements())
-         {
-           for(j=0;j<nj;++j)
-             for(i=0;i<ni;++i)
-             {
-               k=j*ni+i;
-               latvalue_temp(k) = latvalue_1d(j);
-               if (hasBounds)
-               {
-                 for(int n=0;n<nvertex;n++) bounds_lat_temp(n,k) = bounds_lat_1d(n,j);
-               }
-             }
-          }
-          else
-            ERROR("CDomain::completeLonClient(void)",
-                 <<"The latvalue_1d has not the same size as the local domain"<<endl
-                 <<"Local size is "<<nj<<endl
-                 <<"Latvalue_1d size is "<<latvalue_1d.numElements());
-       }
-       else if (type==type_attr::curvilinear || type==type_attr::unstructured)
-       {
-         latvalue_temp=latvalue_1d;
-         if (hasBounds)
-         {
            bounds_lat_temp=bounds_lat_1d;
          }
@@ -548,52 +431,54 @@
      }
 
-     StdSize dm = zoom_ni_client * zoom_nj_client;
+    int i_ind,j_ind;
+    int global_zoom_iend=global_zoom_ibegin+global_zoom_ni-1;
+    int global_zoom_jend=global_zoom_jbegin+global_zoom_nj-1;
+
+    int globalIndexCountZoom = 0;
+    int nbIndex = i_index.numElements();
+    for (i = 0; i < nbIndex; ++i)
+    {
+      i_ind=i_index(i);
+      j_ind=j_index(i);
+
+      if (i_ind >= global_zoom_ibegin && i_ind <= global_zoom_iend && j_ind >= global_zoom_jbegin && j_ind <= global_zoom_jend)
+      {
+        ++globalIndexCountZoom;
+      }
+    }
 
       // Make sure that this attribute is non-empty for every client.
-     if (0 != dm)
-     {
-       latvalue_client.resize(dm);
-       if (hasBounds) bounds_lat_client.resize(nvertex,dm);
-     }
-
-     for (i = 0; i < zoom_ni_client; i++)
-     {
-       for (j = 0; j < zoom_nj_client; j++)
+     if (0 != globalIndexCountZoom)
+     {
+       lonvalue_client.resize(globalIndexCountZoom);
+       latvalue_client.resize(globalIndexCountZoom);
+       if (hasBounds)
        {
-         latvalue_client(i + j * zoom_ni_client) = latvalue_temp( (i + zoom_ibegin_client-ibegin) + (j + zoom_jbegin_client -jbegin)*ni );
+         bounds_lon_client.resize(nvertex,globalIndexCountZoom);
+         bounds_lat_client.resize(nvertex,globalIndexCountZoom);
+       }
+     }
+
+     int nCountZoom = 0;
+     for (i = 0; i < nbIndex; ++i)
+     {
+       i_ind=i_index(i);
+       j_ind=j_index(i);
+
+       if (i_ind >= global_zoom_ibegin && i_ind <= global_zoom_iend && j_ind >= global_zoom_jbegin && j_ind <= global_zoom_jend)
+       {
+         lonvalue_client(nCountZoom) = lonvalue_temp(i);
+         latvalue_client(nCountZoom) = latvalue_temp(i);
          if (hasBounds)
          {
-           for(int n=0;n<nvertex;n++)
+           for (int n = 0; n < nvertex; ++n)
            {
-             bounds_lat_client(n,i + j * zoom_ni_client) = bounds_lat_temp( n, (i + zoom_ibegin_client - ibegin) + (j + zoom_jbegin_client -jbegin)*ni );
+             bounds_lon_client(n,nCountZoom) = bounds_lon_temp(n,i);
+             bounds_lat_client(n,nCountZoom) = bounds_lat_temp(n,i);
            }
          }
+         ++nCountZoom;
        }
      }
-   }
-
-   //----------------------------------------------------------------
-   void CDomain::completeLonLatClient(void)
-   {
-     completeLonClient();
-     completeLatClient();
-   }
-
-
-   //----------------------------------------------------------------
-   void CDomain::checkZoom(void)
-   {
-      int global_zoom_iend=global_zoom_ibegin+global_zoom_ni-1 ;
-      zoom_ibegin_client = ibegin_client > global_zoom_ibegin ? ibegin_client : global_zoom_ibegin ;
-      zoom_iend_client = iend_client < global_zoom_iend ? iend_client : global_zoom_iend ;
-      zoom_ni_client=zoom_iend_client-zoom_ibegin_client+1 ;
-      if (zoom_ni_client<0) zoom_ni_client=0 ;
-
-
-      int global_zoom_jend=global_zoom_jbegin+global_zoom_nj-1 ;
-      zoom_jbegin_client = jbegin_client > global_zoom_jbegin ? jbegin_client : global_zoom_jbegin ;
-      zoom_jend_client = jend_client < global_zoom_jend ? jend_client : global_zoom_jend ;
-      zoom_nj_client=zoom_jend_client-zoom_jbegin_client+1 ;
-      if (zoom_nj_client<0) zoom_nj_client=0;
    }
 
@@ -691,4 +576,54 @@
      hasLonLat = (!latvalue_1d.isEmpty() && !lonvalue_1d.isEmpty()) ||
                  (!latvalue_2d.isEmpty() && !lonvalue_2d.isEmpty());
+     if (hasLonLat)
+     {
+       if (!lonvalue_1d.isEmpty() && !lonvalue_2d.isEmpty())
+         ERROR("CDomain::completeLonLatClient(void)",
+              <<"Only one longitude value can be used but both lonvalue_1d and lonvalue_2d are defined! "<<endl
+              <<"Define only one longitude value: lonvalue_1d or lonvalue_2d ");
+
+       if (!lonvalue_1d.isEmpty() && lonvalue_2d.isEmpty())
+       {
+         if (lonvalue_1d.numElements() != i_index.numElements())
+           ERROR("CDomain::completeLonLatClient(void)",
+                 <<"lonvalue_1d has not the same size as the local domain"<<endl
+                 <<"Local size is "<<i_index.numElements()<<endl
+                 <<"lonvalue_1d size is "<<lonvalue_1d.numElements());
+       }
+
+       if (lonvalue_1d.isEmpty() && !lonvalue_2d.isEmpty())
+       {
+          if ((lonvalue_2d.extent(0) != ni) ||
+              (lonvalue_2d.extent(1) != nj))
+             ERROR("CDomain::completeLonLatClient(void)",
+                   <<"the lonvalue has not the same size as the local domain"<<endl
+                   <<"Local size is "<<ni<<"x"<<nj<<endl
+                   <<"Lonvalue size is "<<lonvalue_2d.extent(0)<<"x"<<lonvalue_2d.extent(1));
+       }
+
+       if (!latvalue_1d.isEmpty() && !latvalue_2d.isEmpty())
+         ERROR("CDomain::completeLonLatClient(void)",
+              <<"Only one longitude value can be used but both latvalue_1d and latvalue_2d are defined! "<<endl
+              <<"Define only one longitude value: latvalue_1d or latvalue_2d ");
+
+       if (!latvalue_1d.isEmpty() && latvalue_2d.isEmpty())
+       {
+         if (latvalue_1d.numElements() != i_index.numElements())
+           ERROR("CDomain::completeLonLatClient(void)",
+                 <<"the latvalue_1d has not the same size as the local domain"<<endl
+                 <<"Local size is "<<i_index.numElements()<<endl
+                 <<"Mask size is "<<latvalue_1d.numElements());
+       }
+
+       if (latvalue_1d.isEmpty() && !latvalue_2d.isEmpty())
+       {
+          if ((latvalue_2d.extent(0) != ni) ||
+              (latvalue_2d.extent(1) != nj))
+             ERROR("CDomain::completeLonLatClient(void)",
+                   <<"the mask has not the same size as the local domain"<<endl
+                   <<"Local size is "<<ni<<"x"<<nj<<endl
+                   <<"Mask size is "<<latvalue_2d.extent(0)<<"x"<<latvalue_2d.extent(1));
+       }
+     }
    }
 
@@ -697,5 +632,4 @@
      CContext* context=CContext::getCurrent() ;
 
-     this->checkZoom();
      if (this->isClientAfterTransformationChecked) return;
      if (context->hasClient)
@@ -742,5 +676,4 @@
      CContext* context=CContext::getCurrent() ;
 
-     this->checkZoom();
      if (this->isChecked) return;
      if (context->hasClient)
@@ -759,5 +692,4 @@
 
       this->checkDomain();
-      this->checkZoom();
       this->checkLonLat();
       this->checkBounds();
@@ -769,5 +701,5 @@
          this->checkDomainData();
          this->checkCompression();
-         this->completeLonLatClient();
+
       }
       else
@@ -777,7 +709,8 @@
       if (context->hasClient)
       {
-        computeConnectedServer() ;
-        sendServerAttribut() ;
-        sendLonLatArea() ;
+        this->computeConnectedServer();
+        this->completeLonLatClient();
+        this->sendServerAttribut();
+        this->sendLonLatArea();
       }
 
@@ -837,7 +770,4 @@
   void CDomain::computeConnectedServer(void)
   {
-    ibegin_client=ibegin; ni_client=ni; iend_client=ibegin_client + ni_client - 1;
-    jbegin_client=jbegin; nj_client=nj; jend_client=jbegin_client + nj_client - 1;
-
     CContext* context=CContext::getCurrent() ;
     CContextClient* client=context->client ;
@@ -846,6 +776,6 @@
 
     int i,j,i_ind,j_ind, nbIndex;
-    int zoom_iend=global_zoom_ibegin+global_zoom_ni-1 ;
-    int zoom_jend=global_zoom_jbegin+global_zoom_nj-1 ;
+    int global_zoom_iend=global_zoom_ibegin+global_zoom_ni-1 ;
+    int global_zoom_jend=global_zoom_jbegin+global_zoom_nj-1 ;
 
     // Precompute number of index
@@ -857,5 +787,5 @@
       j_ind=j_index(i);
 
-      if (i_ind >= global_zoom_ibegin && i_ind <= zoom_iend && j_ind >= global_zoom_jbegin && j_ind <= zoom_jend)
+      if (i_ind >= global_zoom_ibegin && i_ind <= global_zoom_iend && j_ind >= global_zoom_jbegin && j_ind <= global_zoom_jend)
       {
         ++globalIndexCountZoom;
@@ -878,5 +808,5 @@
       globalIndexDomain(globalIndexCount) = globalIndex;
       ++globalIndexCount;
-      if (i_ind >= global_zoom_ibegin && i_ind <= zoom_iend && j_ind >= global_zoom_jbegin && j_ind <= zoom_jend)
+      if (i_ind >= global_zoom_ibegin && i_ind <= global_zoom_iend && j_ind >= global_zoom_jbegin && j_ind <= global_zoom_jend)
       {
         globalIndexDomainZoom(globalIndexCountZoom) = globalIndex;
@@ -1076,10 +1006,6 @@
       {
         idx = static_cast<int>(it->second[n]);
-        i = i_index(idx);
-        j = j_index(idx);
-        ind = (i - zoom_ibegin_client) + (j - zoom_jbegin_client) * zoom_ni_client;
-
-        lon(n) = lonvalue_client(ind);
-        lat(n) = latvalue_client(ind);
+        lon(n) = lonvalue_client(idx);
+        lat(n) = latvalue_client(idx);
 
         if (hasBounds)
@@ -1088,8 +1014,8 @@
           CArray<double,2>& boundslat = list_boundslat.back();
 
-          for (nv = 0; nv < nvertex; nv++)
+          for (nv = 0; nv < nvertex; ++nv)
           {
-            boundslon(nv, n) = bounds_lon_client(nv, ind);
-            boundslat(nv, n) = bounds_lat_client(nv, ind);
+            boundslon(nv, n) = bounds_lon_client(nv, idx);
+            boundslat(nv, n) = bounds_lat_client(nv, idx);
           }
         }
@@ -1252,5 +1178,5 @@
       if (hasBounds)
       {
-        for (int nv = 0; nv < nvertex; nv++)
+        for (int nv = 0; nv < nvertex; ++nv)
           bounds_lon_srv(nv, ind_srv) = boundslon(nv, ind);
       }
Index: /XIOS/trunk/src/node/domain.hpp
===================================================================
--- /XIOS/trunk/src/node/domain.hpp	(revision 665)
+++ /XIOS/trunk/src/node/domain.hpp	(revision 666)
@@ -77,7 +77,5 @@
 
       private :
-
          void checkDomain(void);
-
          void checkLocalIDomain(void);
          void checkLocalJDomain(void);
@@ -87,9 +85,7 @@
          void checkCompression(void);
 
-         void checkZoom(void);
          void checkBounds(void);
          void checkArea(void);
          void checkLonLat();
-
 
       public :
@@ -107,9 +103,9 @@
 
 
-         int ni_client,ibegin_client,iend_client ;
-         int zoom_ni_client,zoom_ibegin_client,zoom_iend_client ;
-
-         int nj_client,jbegin_client,jend_client ;
-         int zoom_nj_client,zoom_jbegin_client,zoom_jend_client ;
+//         int ni_client,ibegin_client,iend_client ;
+//         int zoom_ni_client,zoom_ibegin_client,zoom_iend_client ;
+//
+//         int nj_client,jbegin_client,jend_client ;
+//         int zoom_nj_client,zoom_jbegin_client,zoom_jend_client ;
 
          int ni_srv,ibegin_srv,iend_srv ;
@@ -133,12 +129,10 @@
 
 
-        CArray<int,2> mapConnectedServer ;  // (ni,nj) => mapped to connected server number, -1 if no server is target
+//        CArray<int,2> mapConnectedServer ;  // (ni,nj) => mapped to connected server number, -1 if no server is target
 
         int global_zoom_ibegin, global_zoom_ni;
         int global_zoom_jbegin, global_zoom_nj;
-//        CArray<bool,1> maskInter;
 
       public :
-
          /// Mutateur ///
          void addRelFile(const StdString & filename);
@@ -178,6 +172,4 @@
          void setTransformations(const TransMapTypes&);
          void computeNGlobDomain();
-         void completeLonClient();
-         void completeLatClient();
 
          void sendIndex();
Index: /XIOS/trunk/src/node/grid.cpp
===================================================================
--- /XIOS/trunk/src/node/grid.cpp	(revision 665)
+++ /XIOS/trunk/src/node/grid.cpp	(revision 666)
@@ -686,5 +686,5 @@
       else
       {
-        globalDim_[idx] = axis[idxAxis]->size.getValue();
+        globalDim_[idx] = axis[idxAxis]->n_glo.getValue();
         ++idxAxis;
         ++idx;
@@ -807,5 +807,5 @@
             nZoomSize[indexMap[i]]  = axisList[axisId]->zoom_size_srv;
             nZoomBeginGlobal[indexMap[i]] = axisList[axisId]->global_zoom_begin;
-            nGlob[indexMap[i]] = axisList[axisId]->size;
+            nGlob[indexMap[i]] = axisList[axisId]->n_glo;
             ++axisId;
           }
Index: /XIOS/trunk/src/node/zoom_axis.cpp
===================================================================
--- /XIOS/trunk/src/node/zoom_axis.cpp	(revision 665)
+++ /XIOS/trunk/src/node/zoom_axis.cpp	(revision 666)
@@ -25,14 +25,14 @@
   void CZoomAxis::checkValid(CAxis* axisDest)
   {
-    int axisIBegin, axisNi, axisSize;
+    int axisIBegin, axisNi, axisGlobalSize;
     int zoom_begin, zoom_end, zoom_size;
 
-    axisIBegin = axisDest->ibegin.getValue();
-    axisNi     = axisDest->ni.getValue();
-    axisSize   = axisDest->size.getValue();
+    axisIBegin = axisDest->begin.getValue();
+    axisNi     = axisDest->n.getValue();
+    axisGlobalSize   = axisDest->n_glo.getValue();
 
     zoom_begin = (this->zoom_begin.isEmpty()) ?  0 : this->zoom_begin.getValue() ;
-    zoom_size  = (this->zoom_size.isEmpty()) ?  axisSize : this->zoom_size.getValue() ;
-    zoom_end   = (this->zoom_end.isEmpty()) ?  (axisSize - 1) : this->zoom_end.getValue() ;
+    zoom_size  = (this->zoom_size.isEmpty()) ?  axisGlobalSize : this->zoom_size.getValue() ;
+    zoom_end   = (this->zoom_end.isEmpty()) ?  (axisGlobalSize - 1) : this->zoom_end.getValue() ;
 
     if (this->zoom_begin.isEmpty()) zoom_begin=zoom_end-zoom_size+1;
@@ -40,5 +40,5 @@
     if (this->zoom_end.isEmpty()) zoom_end=zoom_begin+zoom_size-1;
 
-    if ((zoom_begin < 0) || (zoom_begin > axisSize-1) || (zoom_end<0) || (zoom_end>axisSize-1) || (zoom_size<1) || (zoom_size>axisSize) || (zoom_begin>zoom_end))
+    if ((zoom_begin < 0) || (zoom_begin > axisGlobalSize-1) || (zoom_end<0) || (zoom_end>axisGlobalSize-1) || (zoom_size<1) || (zoom_size>axisGlobalSize) || (zoom_begin>zoom_end))
       ERROR("CZoomAxis::checkAttributes(void)",
             << "One or more attributes among <zoom_begin>, <zoom_end>, <zoom_size> of axis transformation [ id = '" << axisDest->getId() << "' , context = '" << CObjectFactory::GetCurrentContextId() << "' ] are not well specified");
Index: /XIOS/trunk/src/test/test_client.f90
===================================================================
--- /XIOS/trunk/src/test/test_client.f90	(revision 665)
+++ /XIOS/trunk/src/test/test_client.f90	(revision 666)
@@ -76,5 +76,5 @@
   PRINT *, "calendar_type = ", calendar_type
 
-  CALL xios_set_axis_attr("axis_A",size=llm ,value=lval) ;
+  CALL xios_set_axis_attr("axis_A",n_glo=llm ,value=lval) ;
   CALL xios_set_domain_attr("domain_A",ni_glo=ni_glo, nj_glo=nj_glo, ibegin=ibegin, ni=ni,jbegin=jbegin,nj=nj,type='curvilinear')
   CALL xios_set_domain_attr("domain_A",data_dim=2, data_ibegin=-1, data_ni=ni+2, data_jbegin=-2, data_nj=nj+4)
Index: /XIOS/trunk/src/test/test_complete.f90
===================================================================
--- /XIOS/trunk/src/test/test_complete.f90	(revision 665)
+++ /XIOS/trunk/src/test/test_complete.f90	(revision 666)
@@ -87,5 +87,5 @@
                             time_origin=xios_date(1999, 01, 01, 15, 00, 00))
 
-  CALL xios_set_axis_attr("axis_atm",size=llm ,value=lval) ;
+  CALL xios_set_axis_attr("axis_atm",n_glo=llm ,value=lval) ;
 
   CALL xios_set_domain_attr("domain_atm",ni_glo=ni_glo, nj_glo=nj_glo, ibegin=ibegin, ni=ni,jbegin=jbegin,nj=nj, type='curvilinear')
@@ -176,8 +176,8 @@
                             time_origin=xios_date(1999, 01, 01, 15, 00, 00))
 
-  CALL xios_set_axis_attr("axis_srf",size=llm ,value=lval)
+  CALL xios_set_axis_attr("axis_srf",n_glo=llm ,value=lval)
   CALL xios_set_domain_attr("domain_srf",ni_glo=ni_glo, nj_glo=nj_glo, ibegin=ibegin, ni=ni,jbegin=jbegin,nj=nj, type='curvilinear')
   CALL xios_set_domain_attr("domain_srf",data_dim=1, data_ibegin=0, data_ni=nb_pt)
-  CALL xios_set_domain_attr("domain_srf",data_n_index=nb_pt, data_i_index=kindex)
+  CALL xios_set_domain_attr("domain_srf",data_i_index=kindex)
   CALL xios_set_domain_attr("domain_srf",lonvalue_2D=lon,latvalue_2D=lat)
 
Index: /XIOS/trunk/src/test/test_new_features.f90
===================================================================
--- /XIOS/trunk/src/test/test_new_features.f90	(revision 665)
+++ /XIOS/trunk/src/test/test_new_features.f90	(revision 666)
@@ -125,9 +125,9 @@
   PRINT *, "calendar_type = ", calendar_type
 
-  CALL xios_set_axis_attr("axis_A", size=ni_glo, ibegin=ibegin, ni=ni, value=lval_ni)
-  CALL xios_set_axis_attr("axis_B", size=nj_glo, ibegin=jbegin, ni=nj, value=lval_nj, mask=mask)
-  CALL xios_set_axis_attr("axis_C", size=llm, value=lval)
-  CALL xios_set_axis_attr("axis_D", size=llm, ibegin=axisBegin, ni=nAxis, value=lvaln)
-  CALL xios_set_axis_attr("axis_G", size=llmInterPolated, value=lvalnInterp, ibegin=axisterpBegin, ni=nAxisinterp)
+  CALL xios_set_axis_attr("axis_A", n_glo=ni_glo, begin=ibegin, n=ni, value=lval_ni)
+  CALL xios_set_axis_attr("axis_B", n_glo=nj_glo, begin=jbegin, n=nj, value=lval_nj, mask=mask)
+  CALL xios_set_axis_attr("axis_C", n_glo=llm, value=lval)
+  CALL xios_set_axis_attr("axis_D", n_glo=llm, begin=axisBegin, n=nAxis, value=lvaln)
+  CALL xios_set_axis_attr("axis_G", n_glo=llmInterPolated, value=lvalnInterp, begin=axisterpBegin, n=nAxisinterp)
   CALL xios_set_domain_attr("domain_A",ni_glo=ni_glo, nj_glo=nj_glo, ibegin=ibegin, ni=ni,jbegin=jbegin,nj=nj)
   CALL xios_set_domain_attr("domain_A",data_dim=2, data_ibegin=-1, data_ni=ni+2, data_jbegin=-2, data_nj=nj+4)
Index: /XIOS/trunk/src/test/test_unstruct_complete.f90
===================================================================
--- /XIOS/trunk/src/test/test_unstruct_complete.f90	(revision 665)
+++ /XIOS/trunk/src/test/test_unstruct_complete.f90	(revision 666)
@@ -199,8 +199,8 @@
   CALL xios_set_current_context(ctx_hdl)
 
-  CALL xios_set_axis_attr("axis_srf",size=llm ,value=lval) ;
+  CALL xios_set_axis_attr("axis_srf",n_glo=llm ,value=lval) ;
   CALL xios_set_domain_attr("domain_srf", ni_glo=ncell_glo, ni=ncell, ibegin=1, i_index=i_index)
   CALL xios_set_domain_attr("domain_srf", type='unstructured', data_dim=1, data_ni=data_n_index, &
-                                          data_n_index=data_n_index, data_i_index=data_i_index)
+                                          data_i_index=data_i_index)
   CALL xios_set_domain_attr("domain_srf", lonvalue_1D=lon, latvalue_1D=lat)
   CALL xios_set_domain_attr("domain_srf", nvertex=4, bounds_lon_1D=bounds_lon, bounds_lat_1D=bounds_lat)
Index: /XIOS/trunk/src/transformation/axis_algorithm_interpolate.cpp
===================================================================
--- /XIOS/trunk/src/transformation/axis_algorithm_interpolate.cpp	(revision 665)
+++ /XIOS/trunk/src/transformation/axis_algorithm_interpolate.cpp	(revision 666)
@@ -20,9 +20,9 @@
   interpAxis->checkValid(axisSource);
   order_ = interpAxis->order.getValue();
-  if (order_ >= axisSource->size.getValue())
+  if (order_ >= axisSource->n_glo.getValue())
   {
     ERROR("CAxisAlgorithmInterpolate::CAxisAlgorithmInterpolate(CAxis* axisDestination, CAxis* axisSource, CInterpolateAxis* interpAxis)",
-           << "Order of interpolation is greater than size of axis source"
-           << "Size of axis source " <<axisSource->getId() << " is " << axisSource->size.getValue()  << std::endl
+           << "Order of interpolation is greater than global size of axis source"
+           << "Size of axis source " <<axisSource->getId() << " is " << axisSource->n_glo.getValue()  << std::endl
            << "Order of interpolation is " << order_ );
   }
@@ -43,5 +43,5 @@
   int nbClient = client->clientSize;
 
-  int srcSize  = axisSrc_->size.getValue();
+  int srcSize  = axisSrc_->n_glo.getValue();
   int numValue = axisValue.numElements();
 
@@ -67,5 +67,5 @@
   const double sfmax = NumTraits<double>::sfmax();
 
-  int ibegin = axisDest_->ibegin.getValue();
+  int ibegin = axisDest_->begin.getValue();
   CArray<double,1>& axisDestValue = axisDest_->value;
   int numValue = axisDestValue.numElements();
@@ -131,5 +131,5 @@
   std::map<int, std::vector<std::pair<int,double> > >::const_iterator itb = interpolatingIndexValues.begin(), it,
                                                                       ite = interpolatingIndexValues.end();
-  int ibegin = axisDest_->ibegin.getValue();
+  int ibegin = axisDest_->begin.getValue();
   for (it = itb; it != ite; ++it)
   {
@@ -169,5 +169,5 @@
   int nbClient = client->clientSize;
 
-  int srcSize  = axisSrc_->size.getValue();
+  int srcSize  = axisSrc_->n_glo.getValue();
   int numValue = axisValue.numElements();
 
@@ -191,5 +191,5 @@
     int* recvIndexBuff = new int [srcSize];
 
-    int ibegin = axisSrc_->ibegin.getValue();
+    int ibegin = axisSrc_->begin.getValue();
     for (int idx = 0; idx < numValue; ++idx)
     {
Index: /XIOS/trunk/src/transformation/axis_algorithm_inverse.cpp
===================================================================
--- /XIOS/trunk/src/transformation/axis_algorithm_inverse.cpp	(revision 665)
+++ /XIOS/trunk/src/transformation/axis_algorithm_inverse.cpp	(revision 666)
@@ -17,15 +17,15 @@
  : CAxisAlgorithmTransformation(axisDestination, axisSource)
 {
-  if (axisDestination->size.getValue() != axisSource->size.getValue())
+  if (axisDestination->n_glo.getValue() != axisSource->n_glo.getValue())
   {
     ERROR("CAxisAlgorithmInverse::CAxisAlgorithmInverse(CAxis* axisDestination, CAxis* axisSource)",
-           << "Two axis have different size"
-           << "Size of axis source " <<axisSource->getId() << " is " << axisSource->size.getValue()  << std::endl
-           << "Size of axis destionation " <<axisDestination->getId() << " is " << axisDestination->size.getValue());
+           << "Two axis have different global size"
+           << "Size of axis source " <<axisSource->getId() << " is " << axisSource->n_glo.getValue()  << std::endl
+           << "Size of axis destionation " <<axisDestination->getId() << " is " << axisDestination->n_glo.getValue());
   }
 
   this->computeIndexSourceMapping();
-  int niSrc   = axisSrc_->ni.getValue();
-  int sizeSrc = axisSrc_->size.getValue();
+  int niSrc   = axisSrc_->n.getValue();
+  int sizeSrc = axisSrc_->n_glo.getValue();
   if (niSrc != sizeSrc) updateAxisValue();
   else
@@ -60,6 +60,6 @@
   CContextClient* client=context->client;
 
-  int niSrc     = axisSrc_->ni.getValue();
-  int ibeginSrc = axisSrc_->ibegin.getValue();
+  int niSrc     = axisSrc_->n.getValue();
+  int ibeginSrc = axisSrc_->begin.getValue();
 
   CTransformationMapping transformationMap(axisDest_, axisSrc_);
@@ -128,5 +128,5 @@
  }
 
- int ibeginDest = axisDest_->ibegin.getValue();
+ int ibeginDest = axisDest_->begin.getValue();
  currentRecvBuff = recvBuff;
  for (itRecv = itbRecv; itRecv != iteRecv; ++itRecv)
Index: /XIOS/trunk/src/transformation/axis_algorithm_transformation.cpp
===================================================================
--- /XIOS/trunk/src/transformation/axis_algorithm_transformation.cpp	(revision 665)
+++ /XIOS/trunk/src/transformation/axis_algorithm_transformation.cpp	(revision 666)
@@ -17,7 +17,7 @@
  : CGenericAlgorithmTransformation(), axisDest_(axisDestination), axisSrc_(axisSource)
 {
-  axisDestGlobalSize_ = axisDestination->size.getValue();
-  int niDest = axisDestination->ni.getValue();
-  int ibeginDest = axisDestination->ibegin.getValue();
+  axisDestGlobalSize_ = axisDestination->n_glo.getValue();
+  int niDest = axisDestination->n.getValue();
+  int ibeginDest = axisDestination->begin.getValue();
 
   for (int idx = 0; idx < niDest; ++idx)
